package net.antonioshome.nbeditorlib.demo;

import java.awt.BorderLayout;
import javax.swing.JComponent;
import javax.swing.JEditorPane;
import net.antonioshome.nbeditorlib.NBEditorFactory;
import net.antonioshome.nbeditorlib.demo.syntax.SchemeEditorKit;
import net.antonioshome.nbeditorlib.demo.syntax.SchemeSettingsInitializer;

/**
 * This is a test frame with a standalone NetBeans Editor.
 * @author $Author: antonio $ Antonio Vieiro (antonio@antonioshome.net)
 * @version $Revision: 1.2 $
 */
public class NBEditorLibDemoFrame extends javax.swing.JFrame
{
  
  /** Creates new form NBEditorLibDemoFrame */
  public NBEditorLibDemoFrame()
  {
    initComponents();
    
    // Create an editor kit for scheme
    SchemeEditorKit editorKit = new SchemeEditorKit();
    
    // Initialize Scheme language support
    NBEditorFactory.addSyntax( editorKit, new SchemeSettingsInitializer() );
    
    // Create a plain editor pane
    JEditorPane editorPane = new JEditorPane();
    
    // Create a renderer to replace the editor pane *visually*
    JComponent renderer = NBEditorFactory.newTextRenderer( editorKit, editorPane );
    
    // Set the text *in the editor pane*
    editorPane.setText("; A scheme definition\n(define i (sqrt -1 ))\n");
    
    // Visualize the *renderer*
    getContentPane().add( renderer, BorderLayout.CENTER );
    
    // Visualize the frame
    setSize( 450, 200 );
    setLocationRelativeTo( null );
    
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
  private void initComponents()
  {

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    setTitle("Standalone NetBeans Editor");
    pack();
  }// </editor-fold>//GEN-END:initComponents
  
  /**
   * @param args the command line arguments
   */
  public static void main(String args[])
  {
    java.awt.EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        new NBEditorLibDemoFrame().setVisible(true);
      }
    });
  }
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  // End of variables declaration//GEN-END:variables
  
}
